
Core - Feature # 24037

Status: Resolved Priority: Should have
Author: Steffen Müller Category: Install Tool
Created: 2010-11-12 Assigned To: Tobias Liebig
Updated: 2012-04-23 Due date:
PHP Version:
Complexity:
Sprint Focus:
Subject: Add "edit end token" to allow custom post configuration in localconf.php
Description

Problem:
"INSTALL SCRIPT EDIT POINT TOKEN" limits the range in localconf.php which is handled by class t3lib_install. Configuration
ABOVE this token is not touched by the t3lib_install.

In some deployment cases it is useful to have some configuration BELOW this range, which is also not touched by t3lib_install. (e.g. to
override config before extensions are loaded).
Details and use cases have already been discussed in TYPO3-dev newsgroup: 
http://lists.typo3.org/pipermail/typo3-dev/2010-October/041857.html

Solution:
Add handling of an end token, which limits the editable range of class t3lib_install.

I tested this successfully with introduction package.

Since introduction package does not completely use the API of t3lib_install, I added a second patch to preserve compatibility.

We could also think about adding this end token in localconf.php of dummy and introduction package

P.S. Please don't blame me for the smelly code. t3lib_install is a hassle. :)

(issue imported from #M16369)

Related issues:
related to Core - Feature # 23911: Allow array as localconf.php configuration... Closed 2010-11-02

Associated revisions
Revision 7ca368e2 - 2012-04-22 15:07 - Tobias Liebig

[FEATURE] New token for custom post configuraton in localconf.php

Some setups require to add a require() statement at the end of the
localconf.php to be able to override the configurations. This patch
introduces a new "edit end token" similar to the existing
"edit token". Only the lines between the "edit token" and the
"edit end token" will be updated by the install tool. The code above
and below that will stay untouched.

Change-Id: I87877503fe71196a7d099f96fb9f4a3018624bd5
Resolves: #24037
Releases: 6.0
Reviewed-on: http://review.typo3.org/10492
Reviewed-by: Tolleiv Nietsch
Tested-by: Tolleiv Nietsch

Revision bf4e379e - 2012-04-29 15:06 - Tobias Liebig

[FEATURE] New token for custom post configuraton in localconf.php

Some setups require to add a require() statement at the end of the
localconf.php to be able to override the configurations. This patch
introduces a new "edit end token" similar to the existing
"edit token". Only the lines between the "edit token" and the
"edit end token" will be updated by the install tool. The code above
and below that will stay untouched.

Change-Id: I87877503fe71196a7d099f96fb9f4a3018624bd5
Resolves: #24037
Releases: 6.0
Reviewed-on: http://review.typo3.org/10492
Reviewed-by: Tolleiv Nietsch
Tested-by: Tolleiv Nietsch

History
#1 - 2010-11-12 19:47 - Steffen Müller

Example localconf.php:

// lines untouched by t3lib_install
...

    1. INSTALL SCRIPT EDIT POINT TOKEN - all lines after this points may be changed by the install script!'
// lines touched by t3lib_install
$GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5'] = 1;
$GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib'] = 1;
$GLOBALS['TYPO3_CONF_VARS']['GFX']['TTFdpi'] = 72
// Updated by ...
    1. INSTALL SCRIPT EDIT END POINT TOKEN - all lines before this points may be changed by the install script!

// lines untouched by t3lib_install
...
$GLOBALS['TYPO3_CONF_VARS']['GFX']['TTFdpi'] =96

?>

#2 - 2010-11-12 20:55 - Chris topher

Is there a way to see in the Install Tool, that some settings (in your example $GLOBALS['TYPO3_CONF_VARS']['GFX']['TTFdpi']) will be overwritten
with unchangable values?
If there is none, people might think that writing to localconf does not work correctly...
#3 - 2010-11-14 11:27 - Xavier Perseguers

@Steffen: please note that I added a relationship to a change that will committed soon.

@Christopher: this could be the opportunity to add a flash message with the reason why a setting was not updated once you click the update button.

#4 - 2012-04-14 16:11 - Tobias Liebig
- Assigned To set to Tobias Liebig
- Target version deleted (0)

#5 - 2012-04-14 16:12 - Tobias Liebig

accidentally voted -1, should have been +1

#6 - 2012-04-14 20:29 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10492

#7 - 2012-04-14 20:31 - Tobias Liebig
- Category set to Install Tool
- % Done changed from 0 to 100
- TYPO3 Version changed from 4.5 to 6.0

We will need that to setup a "best practice" deployment setup with server/envoirment specific localconf configurations. E.g. different database
credentials for the staging and live system.

#8 - 2012-04-15 18:19 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10492

#9 - 2012-04-15 18:24 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10492

#10 - 2012-04-22 15:05 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10492

#11 - 2012-04-23 02:30 - Tobias Liebig
- Status changed from Under Review to Resolved

Applied in changeset commit:7ca368e260385092b7ddea4865084ec5bca5d0bc.

Files
16369.diff 10.1 kB 2010-11-12 Administrator Admin
16369-introduction.diff 906 Bytes 2010-11-12 Administrator Admin
